searchData={"items":[{"type":"module","title":"Geo.PostGIS","doc":"PostGIS functions that can used in ecto queries\n[PostGIS Function Documentation](http://postgis.net/docs/manual-1.3/ch06.html).\n\nCurrently only the OpenGIS functions are implemented.","ref":"Geo.PostGIS.html"},{"type":"module","title":"Examples - Geo.PostGIS","doc":"defmodule Example do\n      import Ecto.Query\n      import Geo.PostGIS\n\n      def example_query(geom) do\n        from location in Location, limit: 5, select: st_distance(location.geom, ^geom)\n      end\n    end","ref":"Geo.PostGIS.html#module-examples"},{"type":"macro","title":"Geo.PostGIS.st_area/1","doc":"","ref":"Geo.PostGIS.html#st_area/1"},{"type":"macro","title":"Geo.PostGIS.st_as_binary/1","doc":"","ref":"Geo.PostGIS.html#st_as_binary/1"},{"type":"macro","title":"Geo.PostGIS.st_as_text/1","doc":"","ref":"Geo.PostGIS.html#st_as_text/1"},{"type":"macro","title":"Geo.PostGIS.st_bd_m_poly_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_bd_m_poly_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_bd_poly_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_bd_poly_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_boundary/1","doc":"","ref":"Geo.PostGIS.html#st_boundary/1"},{"type":"macro","title":"Geo.PostGIS.st_buffer/2","doc":"","ref":"Geo.PostGIS.html#st_buffer/2"},{"type":"macro","title":"Geo.PostGIS.st_buffer/3","doc":"","ref":"Geo.PostGIS.html#st_buffer/3"},{"type":"macro","title":"Geo.PostGIS.st_build_area/1","doc":"","ref":"Geo.PostGIS.html#st_build_area/1"},{"type":"macro","title":"Geo.PostGIS.st_centroid/1","doc":"","ref":"Geo.PostGIS.html#st_centroid/1"},{"type":"macro","title":"Geo.PostGIS.st_collect/1","doc":"","ref":"Geo.PostGIS.html#st_collect/1"},{"type":"macro","title":"Geo.PostGIS.st_collect/2","doc":"","ref":"Geo.PostGIS.html#st_collect/2"},{"type":"macro","title":"Geo.PostGIS.st_contains/2","doc":"","ref":"Geo.PostGIS.html#st_contains/2"},{"type":"macro","title":"Geo.PostGIS.st_convex_hull/1","doc":"","ref":"Geo.PostGIS.html#st_convex_hull/1"},{"type":"macro","title":"Geo.PostGIS.st_covered_by/2","doc":"","ref":"Geo.PostGIS.html#st_covered_by/2"},{"type":"macro","title":"Geo.PostGIS.st_covers/2","doc":"","ref":"Geo.PostGIS.html#st_covers/2"},{"type":"macro","title":"Geo.PostGIS.st_crosses/2","doc":"","ref":"Geo.PostGIS.html#st_crosses/2"},{"type":"macro","title":"Geo.PostGIS.st_difference/2","doc":"","ref":"Geo.PostGIS.html#st_difference/2"},{"type":"macro","title":"Geo.PostGIS.st_dimension/1","doc":"","ref":"Geo.PostGIS.html#st_dimension/1"},{"type":"macro","title":"Geo.PostGIS.st_disjoint/2","doc":"","ref":"Geo.PostGIS.html#st_disjoint/2"},{"type":"macro","title":"Geo.PostGIS.st_distance/2","doc":"","ref":"Geo.PostGIS.html#st_distance/2"},{"type":"macro","title":"Geo.PostGIS.st_distance_in_meters/2","doc":"Casts the 2 geometries given to geographies in order to return distance in meters.","ref":"Geo.PostGIS.html#st_distance_in_meters/2"},{"type":"macro","title":"Geo.PostGIS.st_distance_sphere/2","doc":"Please note that ST_Distance_Sphere has been deprecated as of Postgis 2.2.\nPostgis 2.1 is no longer supported on PostgreSQL >= 9.5.\nThis macro is still in place to support users of PostgreSQL <= 9.4.x.","ref":"Geo.PostGIS.html#st_distance_sphere/2"},{"type":"macro","title":"Geo.PostGIS.st_distancesphere/2","doc":"","ref":"Geo.PostGIS.html#st_distancesphere/2"},{"type":"macro","title":"Geo.PostGIS.st_dwithin/3","doc":"","ref":"Geo.PostGIS.html#st_dwithin/3"},{"type":"macro","title":"Geo.PostGIS.st_dwithin_in_meters/3","doc":"Casts the 2 geometries given to geographies in order to check for distance in meters.","ref":"Geo.PostGIS.html#st_dwithin_in_meters/3"},{"type":"macro","title":"Geo.PostGIS.st_end_point/1","doc":"","ref":"Geo.PostGIS.html#st_end_point/1"},{"type":"macro","title":"Geo.PostGIS.st_envelope/1","doc":"","ref":"Geo.PostGIS.html#st_envelope/1"},{"type":"macro","title":"Geo.PostGIS.st_equals/2","doc":"","ref":"Geo.PostGIS.html#st_equals/2"},{"type":"macro","title":"Geo.PostGIS.st_extent/1","doc":"","ref":"Geo.PostGIS.html#st_extent/1"},{"type":"macro","title":"Geo.PostGIS.st_exterior_ring/1","doc":"","ref":"Geo.PostGIS.html#st_exterior_ring/1"},{"type":"macro","title":"Geo.PostGIS.st_flip_coordinates/1","doc":"","ref":"Geo.PostGIS.html#st_flip_coordinates/1"},{"type":"macro","title":"Geo.PostGIS.st_generate_points/2","doc":"","ref":"Geo.PostGIS.html#st_generate_points/2"},{"type":"macro","title":"Geo.PostGIS.st_generate_points/3","doc":"","ref":"Geo.PostGIS.html#st_generate_points/3"},{"type":"macro","title":"Geo.PostGIS.st_geom_coll_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_geom_coll_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_geom_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_geom_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_geometry_n/2","doc":"","ref":"Geo.PostGIS.html#st_geometry_n/2"},{"type":"macro","title":"Geo.PostGIS.st_geometry_type/1","doc":"","ref":"Geo.PostGIS.html#st_geometry_type/1"},{"type":"macro","title":"Geo.PostGIS.st_interior_ring_n/2","doc":"","ref":"Geo.PostGIS.html#st_interior_ring_n/2"},{"type":"macro","title":"Geo.PostGIS.st_intersection/2","doc":"","ref":"Geo.PostGIS.html#st_intersection/2"},{"type":"macro","title":"Geo.PostGIS.st_intersects/2","doc":"","ref":"Geo.PostGIS.html#st_intersects/2"},{"type":"macro","title":"Geo.PostGIS.st_is_closed/1","doc":"","ref":"Geo.PostGIS.html#st_is_closed/1"},{"type":"macro","title":"Geo.PostGIS.st_is_ring/1","doc":"","ref":"Geo.PostGIS.html#st_is_ring/1"},{"type":"macro","title":"Geo.PostGIS.st_is_simple/1","doc":"","ref":"Geo.PostGIS.html#st_is_simple/1"},{"type":"macro","title":"Geo.PostGIS.st_is_valid/1","doc":"","ref":"Geo.PostGIS.html#st_is_valid/1"},{"type":"macro","title":"Geo.PostGIS.st_length/1","doc":"","ref":"Geo.PostGIS.html#st_length/1"},{"type":"macro","title":"Geo.PostGIS.st_line_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_line_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_line_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_line_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_linestring_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_linestring_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_linestring_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_linestring_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_m/1","doc":"","ref":"Geo.PostGIS.html#st_m/1"},{"type":"macro","title":"Geo.PostGIS.st_m_geom_coll_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_m_geom_coll_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_m_geom_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_m_geom_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_m_geometry_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_m_geometry_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_m_line_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_m_line_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_m_line_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_m_line_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_m_point_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_m_point_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_m_point_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_m_point_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_m_poly_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_m_poly_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_m_poly_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_m_poly_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_make_box_2d/2","doc":"","ref":"Geo.PostGIS.html#st_make_box_2d/2"},{"type":"macro","title":"Geo.PostGIS.st_make_envelope/4","doc":"","ref":"Geo.PostGIS.html#st_make_envelope/4"},{"type":"macro","title":"Geo.PostGIS.st_make_envelope/5","doc":"","ref":"Geo.PostGIS.html#st_make_envelope/5"},{"type":"macro","title":"Geo.PostGIS.st_make_point/2","doc":"","ref":"Geo.PostGIS.html#st_make_point/2"},{"type":"macro","title":"Geo.PostGIS.st_make_point/3","doc":"","ref":"Geo.PostGIS.html#st_make_point/3"},{"type":"macro","title":"Geo.PostGIS.st_make_point/4","doc":"","ref":"Geo.PostGIS.html#st_make_point/4"},{"type":"macro","title":"Geo.PostGIS.st_make_valid/1","doc":"","ref":"Geo.PostGIS.html#st_make_valid/1"},{"type":"macro","title":"Geo.PostGIS.st_make_valid/2","doc":"","ref":"Geo.PostGIS.html#st_make_valid/2"},{"type":"macro","title":"Geo.PostGIS.st_mem_union/1","doc":"","ref":"Geo.PostGIS.html#st_mem_union/1"},{"type":"macro","title":"Geo.PostGIS.st_num_geometries/1","doc":"","ref":"Geo.PostGIS.html#st_num_geometries/1"},{"type":"macro","title":"Geo.PostGIS.st_num_interior_ring/1","doc":"","ref":"Geo.PostGIS.html#st_num_interior_ring/1"},{"type":"macro","title":"Geo.PostGIS.st_num_interior_rings/1","doc":"","ref":"Geo.PostGIS.html#st_num_interior_rings/1"},{"type":"macro","title":"Geo.PostGIS.st_num_points/1","doc":"","ref":"Geo.PostGIS.html#st_num_points/1"},{"type":"macro","title":"Geo.PostGIS.st_overlaps/2","doc":"","ref":"Geo.PostGIS.html#st_overlaps/2"},{"type":"macro","title":"Geo.PostGIS.st_point/2","doc":"","ref":"Geo.PostGIS.html#st_point/2"},{"type":"macro","title":"Geo.PostGIS.st_point_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_point_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_point_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_point_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_point_n/2","doc":"","ref":"Geo.PostGIS.html#st_point_n/2"},{"type":"macro","title":"Geo.PostGIS.st_point_on_surface/1","doc":"","ref":"Geo.PostGIS.html#st_point_on_surface/1"},{"type":"macro","title":"Geo.PostGIS.st_poly_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_poly_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_polygon_from_text/2","doc":"","ref":"Geo.PostGIS.html#st_polygon_from_text/2"},{"type":"macro","title":"Geo.PostGIS.st_polygon_from_wkb/2","doc":"","ref":"Geo.PostGIS.html#st_polygon_from_wkb/2"},{"type":"macro","title":"Geo.PostGIS.st_relate/2","doc":"","ref":"Geo.PostGIS.html#st_relate/2"},{"type":"macro","title":"Geo.PostGIS.st_relate/3","doc":"","ref":"Geo.PostGIS.html#st_relate/3"},{"type":"macro","title":"Geo.PostGIS.st_set_srid/2","doc":"","ref":"Geo.PostGIS.html#st_set_srid/2"},{"type":"macro","title":"Geo.PostGIS.st_shift_longitude/1","doc":"","ref":"Geo.PostGIS.html#st_shift_longitude/1"},{"type":"macro","title":"Geo.PostGIS.st_srid/1","doc":"","ref":"Geo.PostGIS.html#st_srid/1"},{"type":"macro","title":"Geo.PostGIS.st_start_point/1","doc":"","ref":"Geo.PostGIS.html#st_start_point/1"},{"type":"macro","title":"Geo.PostGIS.st_sym_difference/2","doc":"","ref":"Geo.PostGIS.html#st_sym_difference/2"},{"type":"macro","title":"Geo.PostGIS.st_touches/2","doc":"","ref":"Geo.PostGIS.html#st_touches/2"},{"type":"macro","title":"Geo.PostGIS.st_transform/2","doc":"","ref":"Geo.PostGIS.html#st_transform/2"},{"type":"macro","title":"Geo.PostGIS.st_union/1","doc":"","ref":"Geo.PostGIS.html#st_union/1"},{"type":"macro","title":"Geo.PostGIS.st_union/2","doc":"","ref":"Geo.PostGIS.html#st_union/2"},{"type":"macro","title":"Geo.PostGIS.st_within/2","doc":"","ref":"Geo.PostGIS.html#st_within/2"},{"type":"macro","title":"Geo.PostGIS.st_x/1","doc":"","ref":"Geo.PostGIS.html#st_x/1"},{"type":"macro","title":"Geo.PostGIS.st_y/1","doc":"","ref":"Geo.PostGIS.html#st_y/1"},{"type":"macro","title":"Geo.PostGIS.st_z/1","doc":"","ref":"Geo.PostGIS.html#st_z/1"},{"type":"module","title":"Geo.PostGIS.Config","doc":"","ref":"Geo.PostGIS.Config.html"},{"type":"function","title":"Geo.PostGIS.Config.json_library/0","doc":"","ref":"Geo.PostGIS.Config.html#json_library/0"},{"type":"module","title":"Geo.PostGIS.Extension","doc":"PostGIS extension for Postgrex. Supports Geometry and Geography data types.","ref":"Geo.PostGIS.Extension.html"},{"type":"module","title":"Examples - Geo.PostGIS.Extension","doc":"Create a new Postgrex Types module:\n\n    Postgrex.Types.define(MyApp.PostgresTypes, [Geo.PostGIS.Extension], [])\n\nIf using with Ecto, you may want something like thing instead:\n\n    Postgrex.Types.define(MyApp.PostgresTypes,\n                  [Geo.PostGIS.Extension] ++ Ecto.Adapters.Postgres.extensions(),\n                  json: Poison)\n\n    opts = [hostname: \"localhost\", username: \"postgres\", database: \"geo_postgrex_test\",\n    types: MyApp.PostgresTypes ]\n\n    [hostname: \"localhost\", username: \"postgres\", database: \"geo_postgrex_test\",\n      types: MyApp.PostgresTypes]\n\n    {:ok, pid} = Postgrex.Connection.start_link(opts)\n    {:ok, #PID<0.115.0>}\n\n    geo = %Geo.Point{coordinates: {30, -90}, srid: 4326}\n    %Geo.Point{coordinates: {30, -90}, srid: 4326}\n\n    {:ok, _} = Postgrex.Connection.query(pid, \"CREATE TABLE point_test (id int, geom geometry(Point, 4326))\")\n    {:ok, %Postgrex.Result{columns: nil, command: :create_table, num_rows: 0, rows: nil}}\n\n    {:ok, _} = Postgrex.Connection.query(pid, \"INSERT INTO point_test VALUES ($1, $2)\", [42, geo])\n    {:ok, %Postgrex.Result{columns: nil, command: :insert, num_rows: 1, rows: nil}}\n\n    Postgrex.Connection.query(pid, \"SELECT * FROM point_test\")\n    {:ok, %Postgrex.Result{columns: [\"id\", \"geom\"], command: :select, num_rows: 1,\n    rows: [{42, %Geo.Point{coordinates: {30.0, -90.0}, srid: 4326}}]}}","ref":"Geo.PostGIS.Extension.html#module-examples"},{"type":"function","title":"Geo.PostGIS.Extension.decode/1","doc":"","ref":"Geo.PostGIS.Extension.html#decode/1"},{"type":"function","title":"Geo.PostGIS.Extension.encode/1","doc":"","ref":"Geo.PostGIS.Extension.html#encode/1"},{"type":"function","title":"Geo.PostGIS.Extension.format/1","doc":"","ref":"Geo.PostGIS.Extension.html#format/1"},{"type":"function","title":"Geo.PostGIS.Extension.init/1","doc":"","ref":"Geo.PostGIS.Extension.html#init/1"},{"type":"function","title":"Geo.PostGIS.Extension.matching/1","doc":"","ref":"Geo.PostGIS.Extension.html#matching/1"},{"type":"module","title":"Geo.PostGIS.Geometry","doc":"Implements the Ecto.Type behaviour for all geometry types.","ref":"Geo.PostGIS.Geometry.html"},{"type":"function","title":"Geo.PostGIS.Geometry.blank?/1","doc":"","ref":"Geo.PostGIS.Geometry.html#blank?/1"},{"type":"function","title":"Geo.PostGIS.Geometry.cast/1","doc":"","ref":"Geo.PostGIS.Geometry.html#cast/1"},{"type":"function","title":"Geo.PostGIS.Geometry.dump/1","doc":"","ref":"Geo.PostGIS.Geometry.html#dump/1"},{"type":"function","title":"Geo.PostGIS.Geometry.embed_as/1","doc":"","ref":"Geo.PostGIS.Geometry.html#embed_as/1"},{"type":"function","title":"Geo.PostGIS.Geometry.equal?/2","doc":"","ref":"Geo.PostGIS.Geometry.html#equal?/2"},{"type":"function","title":"Geo.PostGIS.Geometry.load/1","doc":"","ref":"Geo.PostGIS.Geometry.html#load/1"},{"type":"function","title":"Geo.PostGIS.Geometry.type/0","doc":"","ref":"Geo.PostGIS.Geometry.html#type/0"},{"type":"type","title":"Geo.PostGIS.Geometry.t/0","doc":"","ref":"Geo.PostGIS.Geometry.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)\nand this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).\n\n## [3.7.0] - 2024-05-08","ref":"changelog.html"},{"type":"extras","title":"New features - Changelog","doc":"* Do not raise on unsuccessful cast, with thanks to new contributor @marmor157 (#156)\n* Added support for `st_make_envelope`, with thanks to @mjquinlan2000 (#195)","ref":"changelog.html#new-features"},{"type":"extras","title":"Updates - Changelog","doc":"* ex_doc updated to v0.32.1\n\n## [3.6.0] - 2024-03-11","ref":"changelog.html#updates"},{"type":"extras","title":"New feature - Changelog","doc":"* Add support for LineStringZM, with thanks to new contributor @versilov (#160)","ref":"changelog.html#new-feature"},{"type":"extras","title":"Fixes and updates - Changelog","doc":"* Silence compile warning by updating `geo` from 3.5.1 to 3.6.0\n* Misc. dependency updates (ex_doc, ecto, ecto_sql, and postgrex)\n\n## [3.5.0] - 2023-09-22","ref":"changelog.html#fixes-and-updates"},{"type":"extras","title":"New features - Changelog","doc":"- [Added ST_MakePoint function](https://github.com/felt/geo_postgis/pull/162) (thanks to new contributor @Slavenin!)\n- [Added ST_IsValid and ST_MakeValid](https://github.com/felt/geo_postgis/pull/146/) (thanks to new contributor @AntoineAugusti!)\n- [Added `Geo.PostGIS.Geometry.t()` for Dialyzer](https://github.com/felt/geo_postgis/pull/173) (thanks to new contributor @RudolfMan!)","ref":"changelog.html#new-features"},{"type":"extras","title":"Bug fix - Changelog","doc":"- [Corrected ST_Crosses fragment](https://github.com/felt/geo_postgis/pull/154) (thanks to new contributor @varjas!)","ref":"changelog.html#bug-fix"},{"type":"extras","title":"Compatibility fix - Changelog","doc":"- [Update geometry.ex to force recompilation on upgrade](https://github.com/felt/geo_postgis/pull/174)—this should make it unnecessary to do the `mix deps.clean` described in the upgrade notes to v3.4.4 below. In my testing, when moving from v3.4.3 to this release, that step was unnecessary; however, beware that it may still be needed when moving from a branch where you're using v3.5.0 to one using v3.4.3 or earlier.\n\n## [3.4.4] - 2023-09-20\n\nAs of v3.4.4, `geo_postgis` is being maintained by the Felt team. As a company building a geospatial product on Elixir, with a track record of [supporting open source software](https://felt.com/open-source), we're excited for the future of the project.","ref":"changelog.html#compatibility-fix"},{"type":"extras","title":"Elixir 1.15 compatibility - Changelog","doc":"This release fixes a major compatibility issue with Elixir v1.15. When compiling a project that depends on `geo_postgis` prior to this release, you may have seen errors like this:\n\n```\n== Compilation error in file lib/my_app/my_module.ex ==\n** (ArgumentError) unknown type Geo.PostGIS.Geometry for field :bounding_box\n    (ecto 3.10.3) lib/ecto/schema.ex:2318: Ecto.Schema.check_field_type!/4\n    (ecto 3.10.3) lib/ecto/schema.ex:1931: Ecto.Schema.__field__/4\n    lib/my_app/my_module.ex:23: (module)\n```\n\n...or:\n\n```\n** (UndefinedFunctionError) function Geo.PostGIS.Geometry.type/0 is undefined (module Geo.PostGIS.Geometry is not available)\n    Geo.PostGIS.Geometry.type()\n```\n\nAs new contributor [@aeruder](https://github.com/aeruder) [pointed out](https://github.com/felt/geo_postgis/pull/164), this was due to a change in how Elixir 1.15 prunes code more precisely when compiling dependencies, resulting in the `Geo.PostGIS.Geometry` module being compiled out if Ecto didn't _happen_ to get compiled before it. This release fixes the issue, but you'll still need to recompile both `geo_postgis` and `ecto` to get things working again.","ref":"changelog.html#elixir-1-15-compatibility"},{"type":"extras","title":"Upgrade notes - Changelog","doc":"If you're using Elixir 1.15, after installing v3.4.4, you'll need to run:\n\n```sh\nmix deps.clean geo_postgis ecto && mix deps.get\n```\n\n(Alternatively, a full clean build of your project will also do the job.)\n\nDoing so will ensure `geo_postgis` compiles with the Ecto dependency and fixes the compilation errors noted above.\n\nNote that you'll _also_ need to run the above one-liner if you need to switch back to a previous version of `geo_postgis` (e.g., when moving between branches). However, if you can stick with the new version going forward, you'll only have to run it once.","ref":"changelog.html#upgrade-notes"},{"type":"extras","title":"Fixed - Changelog","doc":"- Elixir 1.15 compatibility (see notes above)\n- [Called out the optional Ecto dependency in `mix.exs`](https://github.com/felt/geo_postgis/pull/164)\n- [Updated docs links to point to the project's new home in the Felt GitHub organization](https://github.com/felt/geo_postgis/pull/170)\n- Dependency updates for `ecto_sql`, `postgrex`, and `ex_doc`\n- Bumped the minimum Elixir version to v1.11, matching `postgrex` v0.16.0+\n\n## [3.4.3] - 2023-06-20","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"-  [Corrected bitstring specifier int32 and updated deps](https://github.com/felt/geo_postgis/pull/158)\n\n## [3.4.2] - 2022-02-23","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"-  [Fixed compilation error introduced in #121](https://github.com/felt/geo_postgis/pull/128)\n\n## [3.4.1] - 2021-12-15","ref":"changelog.html#fixed"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Add [Geo.PostGIS.st_build_area/1](https://github.com/felt/geo_postgis/pull/115)\n\n## [3.4.0] - 2021-04-10","ref":"changelog.html#enhancements"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Update to Geo 3.4.0\n- `Geo.PostGIS.Extension` now uses the `:binary` format instead of `:text`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Changes - Changelog","doc":"- Passing latitude or longitude as string instead of floats is no longer supported and raises an `argument error`\n\n## [3.3.1] - 2019-12-13","ref":"changelog.html#changes"},{"type":"extras","title":"Fixed - Changelog","doc":"- [Add new callback functions required by ecto 3](https://github.com/felt/geo_postgis/pull/55)\n- [Ecto 3.2+ requires callbacks for custom types](https://github.com/felt/geo_postgis/pull/59)\n\n## [3.3.0] - 2019-08-26","ref":"changelog.html#fixed"},{"type":"extras","title":"Updated - Changelog","doc":"- Geo dependency to 3.3\n\n## [3.2.0] - 2019-07-23","ref":"changelog.html#updated"},{"type":"extras","title":"Add - Changelog","doc":"- [Z versions of the datatypes](https://github.com/felt/geo_postgis/pull/44)\n\n## [3.1.0] - 2019-02-11","ref":"changelog.html#add"},{"type":"extras","title":"Updated - Changelog","doc":"- [Add PointZ handling](https://github.com/felt/geo_postgis/pull/25)\n\n## [3.0.0] - 2018-12-01","ref":"changelog.html#updated"},{"type":"extras","title":"Updated - Changelog","doc":"- Support for Ecto 3.0\n\n## [2.1.0] - 2018-08-28","ref":"changelog.html#updated"},{"type":"extras","title":"Added - Changelog","doc":"- [Geo.PostGIS.st_point/2](https://github.com/felt/geo_postgis/pull/6)","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- [st_distance_in_meters/2](https://github.com/felt/geo_postgis/pull/8)\n\n## [2.0.0] - 2018-04-14","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Use `Geo.PostGIS.Geometry` when defining structs instead of `Geo.Geometry`\n\n```elixir\n  #instead of\n  schema \"test\" do\n    field :name,           :string\n    field :geom,           Geo.Geometry # or Geo.Point, Geo.LineString, etc\n  end\n\n  #now use\n  schema \"test\" do\n    field :name,           :string\n    field :geom,           Geo.PostGIS.Geometry\n  end\n```\n\n## [1.1.0] - 2018-01-28","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- [Add ST_Collect()](https://github.com/felt/geo_postgis/pull/3)\n\n## [1.0.0] - 2017-07-15","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- PostGIS extension for Postgrex","ref":"changelog.html#added"},{"type":"extras","title":"GeoPostGIS","doc":"# GeoPostGIS\n\n[![Build & Test Status](https://github.com/felt/geo_postgis/actions/workflows/elixir-build-and-test.yml/badge.svg?branch=master)](https://github.com/felt/geo_postgis/actions/workflows/elixir-build-and-test.yml)\n[![Module Version](https://img.shields.io/hexpm/v/geo_postgis.svg)](https://hex.pm/packages/geo_postgis)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/geo_postgis/)\n[![Total Download](https://img.shields.io/hexpm/dt/geo_postgis.svg)](https://hex.pm/packages/geo_postgis)\n[![License](https://img.shields.io/hexpm/l/geo_postgis.svg)](https://github.com/felt/geo_postgis/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/felt/geo_postgis.svg)](https://github.com/felt/geo_postgis/commits/master)\n\nPostgrex extension for the PostGIS data types. Uses the [geo](https://github.com/felt/geo) library","ref":"readme.html"},{"type":"extras","title":"Installation - GeoPostGIS","doc":"The package can be installed by adding `:geo_postgis` to your list of\ndependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:geo_postgis, \"~> 3.7\"}\n  ]\nend\n```\n\nMake sure PostGIS extension to your database is installed. More information [here](https://trac.osgeo.org/postgis/wiki/UsersWikiPostGIS24UbuntuPGSQL10Apt#Install)","ref":"readme.html#installation"},{"type":"extras","title":"Optional Configuration - GeoPostGIS","doc":"```elixir\n# When a binary is passed to `Geo.PostGIS.Geometry.cast/1` implementation of\n# `Ecto.Type.cast/1`, it is assumed to be a GeoJSON string. When this happens,\n# geo_postgis will use Poison, by default, to convert the binary to a map and\n# then convert that map to one of the Geo structs. If in these cases you would\n# like to use a different JSON parser, you can set the config below.\n\n# config.exs\nconfig :geo_postgis,\n  json_library: Jason # If you want to set your JSON module\n```","ref":"readme.html#optional-configuration"},{"type":"extras","title":"Examples - GeoPostGIS","doc":"Postgrex Extension for the PostGIS data types, Geometry and Geography:\n\n```elixir\nPostgrex.Types.define(MyApp.PostgresTypes, [Geo.PostGIS.Extension], [])\n\nopts = [hostname: \"localhost\", username: \"postgres\", database: \"geo_postgrex_test\", types: MyApp.PostgresTypes ]\n[hostname: \"localhost\", username: \"postgres\", database: \"geo_postgrex_test\", types: MyApp.PostgresTypes]\n\n{:ok, pid} = Postgrex.Connection.start_link(opts)\n{:ok, #PID<0.115.0>}\n\ngeo = %Geo.Point{coordinates: {30, -90}, srid: 4326}\n%Geo.Point{coordinates: {30, -90}, srid: 4326}\n\n{:ok, _} = Postgrex.Connection.query(pid, \"CREATE TABLE point_test (id int, geom geometry(Point, 4326))\")\n{:ok, %Postgrex.Result{columns: nil, command: :create_table, num_rows: 0, rows: nil}}\n\n{:ok, _} = Postgrex.Connection.query(pid, \"INSERT INTO point_test VALUES ($1, $2)\", [42, geo])\n{:ok, %Postgrex.Result{columns: nil, command: :insert, num_rows: 1, rows: nil}}\n\nPostgrex.Connection.query(pid, \"SELECT * FROM point_test\")\n{:ok, %Postgrex.Result{columns: [\"id\", \"geom\"], command: :select, num_rows: 1,\nrows: [{42, %Geo.Point{coordinates: {30.0, -90.0}, srid: 4326 }}]}}\n```\n\nUse with [Ecto](https://hexdocs.pm/ecto_sql/Ecto.Adapters.Postgres.html#module-extensions):\n\n```elixir\n#If using with Ecto, you may want something like thing instead\nPostgrex.Types.define(MyApp.PostgresTypes,\n              [Geo.PostGIS.Extension] ++ Ecto.Adapters.Postgres.extensions(),\n              json: Jason)\n\n#Add extensions to your repo config\nconfig :thanks, Repo,\n  database: \"geo_postgrex_test\",\n  username: \"postgres\",\n  password: \"postgres\",\n  hostname: \"localhost\",\n  adapter: Ecto.Adapters.Postgres,\n  types: MyApp.PostgresTypes\n\n\n#Create a schema\ndefmodule Test do\n  use Ecto.Schema\n\n  schema \"test\" do\n    field :name,           :string\n    field :geom,           Geo.PostGIS.Geometry\n  end\nend\n\n#Geometry or Geography columns can be created in migrations too\ndefmodule Repo.Migrations.Init do\n  use Ecto.Migration\n\n  def up do\n    create table(:test) do\n      add :name,     :string\n      add :geom,     :geometry\n    end\n  end\n\n  def down do\n    drop table(:test)\n  end\nend\n```\n\nEcto migrations can also use more elaborate [PostGIS GIS Objects](http://postgis.net/docs/using_postgis_dbmanagement.html#RefObject). These types are useful for enforcing constraints on `{Lng,Lat}` (order matters), or ensuring that a particular projection/coordinate system/format is used.\n\n```elixir\ndefmodule Repo.Migrations.AdvancedInit do\n  use Ecto.Migration\n\n  def up do\n    create table(:test) do\n      add :name,     :string\n    end\n    # Add a field `lng_lat_point` with type `geometry(Point,4326)`.\n    # This can store a \"standard GPS\" (epsg4326) coordinate pair {longitude,latitude}.\n    execute(\"SELECT AddGeometryColumn ('test','lng_lat_point',4326,'POINT',2);\")\n\n    # Once a GIS data table exceeds a few thousand rows, you will want to build an index to speed up spatial searches of the data\n    # Syntax - CREATE INDEX [indexname] ON [tablename] USING GIST ( [geometryfield] );\n    execute(\"CREATE INDEX test_geom_idx ON test USING GIST (lng_lat_point);\")\n  end\n\n  def down do\n    drop table(:test)\n  end\nend\n```\n\nBe sure to enable the PostGIS extension if you haven't already done so:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.EnablePostgis do\n  use Ecto.Migration\n\n  def up do\n    execute \"CREATE EXTENSION IF NOT EXISTS postgis\"\n  end\n\n  def down do\n    execute \"DROP EXTENSION IF EXISTS postgis\"\n  end\nend\n```\n\n[PostGIS functions](http://postgis.net/docs/manual-1.3/ch06.html) can also be used in Ecto queries. Currently only the OpenGIS functions are implemented. Have a look at [lib/geo_postgis.ex](lib/geo_postgis.ex) for the implemented functions. You can use them like:\n\n```elixir\ndefmodule Example do\n  import Ecto.Query\n  import Geo.PostGIS\n\n  def example_query(geom) do\n    query = from location in Location, limit: 5, select: st_distance(location.geom, ^geom)\n    query\n    |> Repo.one\n  end\nend\n```","ref":"readme.html#examples"},{"type":"extras","title":"Development - GeoPostGIS","doc":"After you got the dependencies via `mix deps.get` make sure that:\n\n* `postgis` is installed\n* your `postgres` user has the database `\"geo_postgrex_test\"`\n* your `postgres` db user can login without a password or you set the `PGPASSWORD` environment variable appropriately\n\nThen you can run the tests as you are used to with `mix test`.","ref":"readme.html#development"},{"type":"extras","title":"Copyright and License - GeoPostGIS","doc":"Copyright (c) 2017 Bryan Joseph\n\nReleased under the MIT License, which can be found in the repository in [`LICENSE`](https://github.com/felt/geo_postgis/blob/master/LICENSE).","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}